using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

using TEAMModelOS.SDK.Context.Attributes.Azure;


namespace TEAMModelOS.SDK.Models
{
    /// <summary>
    /// 作业
    /// </summary>    
    public class Homework:CosmosEntity
    {        
        public Homework()
        {
           

            resource = new List<ProcessRes>();
        }   

        /// <summary>
        /// 作业名称
        /// </summary>
        public string name { get; set; }

       

        /// <summary>
        /// 发布模式 0 立即发布 1 定时
        /// </summary>
        public string publishModel { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        public long startTime { get; set; }

        /// <summary>
        /// 结束时间
        /// </summary>
        public long endTime { get; set; }
        //记录ServiceBus每条消息的编号

        public long sequenceNumber { get; set; }





        /// <summary>
        /// 作业描述
        /// </summary>
        public string description { get; set; }

  
        /// <summary>
        /// 作业附件
        /// </summary>
        public List<ProcessRes> resource { get; set; }


        /// <summary>
        /// 状态 （100：待发布 200：已发布 300：已结束）
        /// </summary>
        public int status { get; set; }

        //public Subdto subdto { get; set; }

        /// <summary>
        /// 学生 是否互评 是否可见 
        /// </summary>
        public List<string> other { get; set; }
        //创建时间 
        public long createTime { get; set; }
        


    }
}
