using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;
using TEAMModelOS.SDK.Models.Cosmos.Common;

namespace TEAMModelOS.SDK.Models.Cosmos
{
    /// <summary>
    /// 课纲-我喜欢的，我的收藏
    /// </summary>
    public class Favorite : CosmosEntity
    {
        public Favorite() {
            pk = "Favorite";
            ttl = -1;
            //code ="Favorite-tmdid"
        }
        public SyllabusTree node { get; set; }
        /// <summary>
        /// 名称 默认选中节点名称，或者自定义输入名称
        /// </summary>
        public string name { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        public long createTime { get; set; }
        /// <summary>
        /// 引用来源课纲id
        /// </summary>
        [Required(ErrorMessage = "引用来源课纲id 必须设置")]
        public string fromId { get; set; }
        /// <summary>
        /// 引用来源 课纲Code 分区键
        /// </summary>
        [Required(ErrorMessage = "引用来源课纲code 必须设置")]
        public string fromCode { get; set; }
    }
}
