import { post } from '@/api/http';

export default{
    /**
     * 开放平台列表
     * @param {code: "学校编码"} data
     */
    getOpenList: function (data) {
        return post('/open-api/find-app', data)
    },
    /**
     * 获取token
     * @param {id: "应用id", code: "学校编码"} data
     */
    getToken: function (data) {
        return post('/open-api/create-token', data)
    },
    /**
     * 获取api
     * @param {} data
     */
    getApiList: function (data) {
        return post('/open-api/get', data)
    },
    /**
     * 新增/编辑
     * @param {
     *          id: "应用id", ====> 编辑才有
     *          code: "学校编码",
     *          name: "应用名称",
     *          descr: "描述",
     *          auths: [选择的api 的 auth],
     *          school: "",
     *          status: 状态
     *        } data
     */
    editOpenInfo: function (data) {
        return post('/open-api/upsert-app', data)
    },
    /**
     * 删除
     * @param {id: "应用id", code: "学校编码"} data
     */
    delOpen: function (data) {
        return post('/open-api/delete-app', data)
    }
}