using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;
using System.Text.Json.Serialization;
using TEAMModelOS.SDK.Context.Attributes.Azure;
using TEAMModelOS.SDK.DI;

namespace TEAMModelOS.SDK.Models
{
    /// <summary>
    /// 考试基础信息
    /// </summary>
   
    public class ExamInfoDto : CosmosEntity
    {        
        public ExamInfoDto()
        {
        }       

        public string name { get; set; }
        public int stuCount { get; set; }
        //实际考试人数
        public int realCount { get; set; }
        //平均分
        public double piont { get; set; }
        //指标
        public double index { get; set; }
        public long createTime { get; set; }
        public string examCode { get; set; }

        /// <summary>
        /// 施测起始时间
        /// </summary>
        public long startTime { get; set; }
        /// <summary>
        /// 施测结束时间
        /// </summary>
        public long endTime { get; set; }
        /// <summary>
        /// 施测对象
        /// </summary>
        public List<string> target { get; set; }
        /// <summary>
        /// 发布
        /// </summary>
        public string publish { get; set; }

        public int status { get; set; }
        /// <summary>
        ///考试类型 段考 stage  联考 union 平常考 normal 其他 other
        /// </summary>
        public string type { get; set; }
        public long sequenceNumber { get; set; }
        public Condition conditions { get; set; }
        public List<string> blobUrl { get; set; }
        /// <summary>
        /// 所有试卷阅卷状态
        /// </summary>
        public List<int> marks { get; set; }
    }
    public class Condition
    {
        public string period { get; set; }
        public string grade { get; set; }
        public string semester { get; set; }
        /// <summary>
        /// 评测范围 class 班级测验，年级测验 grade , 区级测验 distric
        /// </summary>
        public string range { get; set; }
        /// <summary>
        /// feedBackType ==>>source 评测来源 考试阅卷 marking ,互动课堂 teach ,线上评测 exam ，手动录入import
        /// </summary>
        public string source { get; set; }
        /// <summary>
        /// 科目
        /// </summary>
        public List<string> subject { get; set; }
    }

}
